const isBrowser = typeof window !== "undefined" && typeof window.document !== "undefined";

const isNode =
  typeof process !== "undefined" && process.versions != null && process.versions.node != null;

const isWebWorker =
  typeof self === "object" &&
  self.constructor &&
  self.constructor.name === "DedicatedWorkerGlobalScope";

const isJsDom =
  (typeof window !== "undefined" && window.name === "nodejs") ||
  (typeof navigator !== "undefined" &&
    (navigator.userAgent.includes("Node.js") || navigator.userAgent.includes("jsdom")));

const isDeno = typeof Deno !== "undefined" && typeof Deno.core !== "undefined";

module.exports = { isBrowser, isWebWorker, isNode, isJsDom, isDeno };
